package me.paradoxpixel.themepark.listener;

import me.paradoxpixel.themepark.ThemeParkPlugin;
import me.paradoxpixel.themepark.attraction.AttractionMenu;
import me.paradoxpixel.themepark.config.YamlConfig;
import me.paradoxpixel.themepark.utils.Utils;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.inventory.ItemStack;

public class ClickListener implements Listener {

    private YamlConfig config = ThemeParkPlugin.getInstance().getSettings();

    @EventHandler
    public void onInteract(PlayerInteractEvent e) {
        Material material = Material.getMaterial(config.getConfig().getString("item.material"));
        String name = Utils.color(config.getConfig().getString("item.display-name"));
        if(e.getItem() == null)
            return;

        ItemStack item = e.getItem();
        if(item.getType() != material)
            return;

        if(!item.hasItemMeta())
            return;

        if(!item.getItemMeta().getDisplayName().equals(name))
            return;

        if(e.getAction() == Action.LEFT_CLICK_AIR ||
                e.getAction() == Action.LEFT_CLICK_BLOCK)
            return;

        e.setCancelled(true);
        Player player = e.getPlayer();
        AttractionMenu.openMenu(player);
    }

}
